
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;


public class MyCharon {
    
    String TargetServer;
    ServerSocket server;
    PrintWriter out;
    BufferedOutputStream bos,out1,out2;

    String RequestType, RequestFile, RequestURL, RequestParameters;
    boolean binary;
    boolean headerflag;
    byte[] buf;
    URLConnection conn;
    String myID,myCookie;
    BufferedInputStream bif;
    int blksize; 

    String BrowserPath="netscape";   
    String startPage="/cyoun";
    String LocalServer;
    Hashtable clients;
    boolean startflag = true;
    boolean sendflag = true;
    Socket socket = null;

    public MyCharon(String TargetServer,String Port) {

	clients = new Hashtable();
	blksize=1024;		
	LocalServer="http://localhost:"+Port;
	System.out.println(LocalServer);
	this.TargetServer = TargetServer;
	//startBrowser();
	
	//Now open the socket on the client and listen for requests.
	try {
	    server = new ServerSocket(Integer.parseInt(Port));     

	    while (true) {
		/* listen to requests from the local web browser */
		System.out.println("waiting for requests...");
		System.out.println("Server: "+server.toString());

		if(!startflag) server.setSoTimeout(400); //500msec is OK
		
		try {
		    socket = server.accept();
		    startflag = true;
		} catch(java.io.InterruptedIOException e) {
		    System.out.println(e);
		    server.setSoTimeout(0);
		    startflag = true;
		    sendflag = true;
		    socket = server.accept();
		}

		System.out.println("Accept: "+socket.toString());

		InetAddress host=socket.getInetAddress();
		String hostaddress = host.getHostAddress();

	        String callBack1="localhost"; //pet03.asc.hpc.mil";
	        int callBackPort1=9596;
		Socket acceptor1 = null;
		BufferedReader in1 = null;

	        //String callBack2="localhost"; //"pet03.asc.hpc.mil";
	        //int callBackPort2=9898;
	        //int timeout=100000;

		/*
		BufferedReader stdin=
		    new BufferedReader(new InputStreamReader(System.in));

		String getstdin = null; 
	        getstdin = stdin.readLine();	       
		*/

	        System.out.println("Server can now accept connections.");
		if(sendflag) {

		    try {
			acceptor1=new Socket(callBack1,callBackPort1);
			//Socket acceptor2=new Socket(callBack2,callBackPort2);
			if(acceptor1==null) {
			    System.out.println("Socket is null");
			    System.exit(1);
			}
			else {
			    System.out.println("Connection accepted");
			}
			
			in1 = new BufferedReader(new 		
			    InputStreamReader(acceptor1.getInputStream()));
			//PrintWriter out1=
			// new PrintWriter(acceptor1.getOutputStream(),true);
			out1 = new BufferedOutputStream(acceptor1.getOutputStream());

			//BufferedReader in2=
			//new BufferedReader(new 		
			//InputStreamReader(acceptor2.getInputStream()));
			//PrintWriter out2=
			//new PrintWriter(acceptor2.getOutputStream(),true);
			//out2 = new BufferedOutputStream(acceptor2.getOutputStream());
		    } catch(java.net.ConnectException ex) {
			System.out.println("Error: "+ex);
		    }
		    
		}

		/*
		if(!hostaddress.equals("127.0.0.1")) {
		    System.out.println(" ===================== ");
		    System.out.println("Warning: unauthorized access from "+hostaddress);
		    System.exit(0);
		}
		*/
 
		/* read and parse request */
		
		BufferedReader in = 
		    new BufferedReader(new InputStreamReader(socket.getInputStream()));
		String str = in.readLine();
		System.out.println("Str : "+str);
		
		if(sendflag) {
		    System.out.println("Send data........");
		    byte[] strbyte = str.getBytes();
		    out1.write(strbyte,0,strbyte.length);
		    out1.flush();
		}

		/* the first line should be the request */
		StringTokenizer st = new StringTokenizer(str);
		RequestType = st.nextToken();
		RequestFile = st.nextToken();
		System.out.println("Request File: "+RequestFile);

		if(RequestFile.equals("/cyoun")) {
		    clients.put("cyoun", socket);
		    RequestFile = "/GOW/CharonStart.jsp";
		}

		RequestURL = TargetServer+RequestFile;
		System.out.println("request type: "+RequestType);
		System.out.println("request  url: "+RequestURL);
		
		//For kerberized Charon, html and servlet files must be
		//passed as binary.  Or maybe this is an apache thing
		//and Jigsaw can pass things as strings. --Marlon

		binary=true;  
		//if(RequestFile.endsWith(".html")) binary=false;
		//if(RequestFile.endsWith(".HTML")) binary=false;
		//if(RequestFile.endsWith(".htm")) binary=false;
		//if(RequestFile.endsWith(".HTM")) binary=false;
		//if(RequestFile.endsWith(".txt")) binary=false;
		//if(RequestFile.endsWith(".TXT")) binary=false;
		//if(RequestFile.indexOf("servlets")>-1) binary=false;

		System.out.println("binary set to "+binary);
		System.out.println("Servlet index: "
				   +RequestFile.indexOf("servlet"));
		
		/* read the request to the end */
		/*
		StringTokenizer t;
		while (!str.equals("")) {
		    try {
			str=in.readLine();
			t=new StringTokenizer(str," :=;");
			while(t.hasMoreTokens()){
			    if(t.nextToken().equals("JSESSIONID"))
				CharonCookieVal=t.nextToken();
			}
			System.out.println(str);
		    } catch (java.lang.NullPointerException e) {}
		}

		System.out.println("while completed");
		*/

		/* Add the following to handle Post requests */
		if(RequestType.equals("POST")) {
		    //read parameters
		    RequestParameters = in.readLine();
		    RequestURL += "?"+RequestParameters;
		} 

		/*
		System.out.println(CharonCookieVal);
		if(CharonCookieVal!=null){
		    charon.setSessionCookie(CharonCookieVal);
		    System.out.println("Session Value: "+charon.getSessionCookie());
		}
		*/

		/* open output stream to browser */	
		try {
		    OutputStream os=socket.getOutputStream();
		    if(binary) {bos = new BufferedOutputStream(os);}
		    else {out = new PrintWriter(os,true);}
		    // out = new PrintWriter(os,true);
		} catch (Exception e) {
		    System.out.println("cannot open output stream...");
		    System.out.println(e);
		}
		
		/* make request on behalf of the browser */
		
		if(connect(RequestURL)){

		    startflag = false;
		    try {
			if(binary) {
			    buf = getBinaryBlock();
			    while(buf.length>1) {
				bos.write(buf,0,buf.length);
				//out1.write(buf,0,buf.length);
				//out2.write(buf,0,buf.length);
				
				bos.flush();
				//out1.flush();
				//out2.flush();
				buf = getBinaryBlock();
			    } 
			}
			
			/*		
		String webbrowserinit = "<A HREF=\"/\">dddd </A>";
		byte[] wbinit = webbrowserinit.getBytes();
		out1.write(wbinit,0,wbinit.length);
		out1.flush();
			*/
			/*	
		String webbrowserinit = "HTTP/1.0 200 OK \n";
		webbrowserinit += "Date: Monday, 05-Feb-01 06:25:12 GMT \n";
		webbrowserinit += "Server: Apache/1.3.12 (Unix) mod_ssl/2.6.5 OpenSSL/0.9.5a ApacheJServ/1.1.1 \n";
		webbrowserinit += "Last-modified: Fri, 05 Jan 1997 06:25:12 GMT \n";
		webbrowserinit += "ETag: \"1296501-db-32d629df\" \n";
		webbrowserinit += "Accept-Ranges: bytes \n";
		webbrowserinit += "Content-Length: 2310 \n";
		webbrowserinit += "Connection: close \n";
		webbrowserinit += "Content-type: text/html \n";
		webbrowserinit += "\n";
		webbrowserinit += "<HTML> \n";
		webbrowserinit += "...\n";
		webbrowserinit += "</HTML>";

		//System.out.println(webbrowserinit);

		byte[] wbinit = webbrowserinit.getBytes();
		out1.write(wbinit,0,wbinit.length);
		out1.flush();
			*/

			socket.close();
			if(sendflag) {
			    sendflag = false;
			    acceptor1.close();
			}
			//acceptor2.close();
		    } catch (Exception e) {
			System.out.println("IO error writing back to browser");
			closeConnection();
			socket.close();
			if(sendflag) { 
			    acceptor1.close();
			    sendflag = false;
			}
			//acceptor2.close();
			System.out.println(e);
		    }
		}
		else {
		    System.out.println("cannot open URL: "+RequestURL);
		} 
	    }  //Ends the while block.
	} 
	catch (IOException e)
	    {
		System.out.println("Conection not established with server "+e);
	    }
    }
            
    public void startBrowser() {
	//String session=charon.getKerberosID();
	try {
	    String path=BrowserPath+" "+LocalServer+startPage;
	    System.out.println(path);
	    Process p=Runtime.getRuntime().exec(path);
	}
	catch (IOException e) {
	    System.out.println(e);
	}
    }
             
    public boolean connect(String UrlString) {
	boolean status=true; 
	headerflag=true;
	try {
	    URL url = new URL(UrlString);
	    //      InputStream is = url.openStream();
	    //I added the stuff below--Marlon.
	    conn=url.openConnection();
	    conn.setDoOutput(true);
	    conn.setDoInput(true);
	    conn.setDefaultUseCaches(false);
	    conn.setUseCaches(false);
	    conn.setRequestProperty("Content-Type",
                                    "application/x-www-form-urlencoded");

	    //conn.setRequestProperty("Cookie","kerID="+myID);
	    //System.out.println("Kerid is set: "+myID);
	    //if(myCookie!=null){
	    //conn.setRequestProperty("Cookie","JESSIONID="+myCookie
	    //+"; kerID="+myID );
	    //System.out.println("JSESSIONID is set: "+myCookie);
	    //}

	    conn.connect();
	    //	    System.out.println("Test header: "+conn.getHeaderField("Set-Cookie"));
	    InputStream is=conn.getInputStream();
	    bif = new BufferedInputStream(is);

	    String sss = conn.toString();
	    System.out.println(sss);

	    //Talk back to the server. --Marlon
//  	    OutputStream out=conn.getOutputStream();
//  	    bos=new BufferedOutputStream(out);
	    
	} catch (Exception e) {
	    System.out.println("cannot connect to "+UrlString);
	    System.out.println(e.toString());
	    status=false;
	}
	return status;
    } 

    public byte[] getBinaryBlock() {

//    	conn.setRequestProperty("Cookie",myID);
//  	byte[] tmp=conn.getRequestProperty("Cookie").getBytes();
//  	try {
//    	    bos.write(tmp,0,tmp.length);
//    	    bos.flush();
//    	}
//    	catch (Exception e) {System.out.println(e);}
	
	//I have modified this to first send the header info to 
	//the client (in binary) and then send the contents of the
	//URL.
	byte[] a = null; 
	byte[] b = new byte[blksize];
	//Return header information first
	System.out.println("In binary block");
	if(headerflag) {
	    String holder="HTTP/1.0 200 OK \n";
	    String key;
	    int n=1;
	    while((key=conn.getHeaderFieldKey(n)) !=null){
		holder+=key+": "+
		    conn.getHeaderField(key) +"\n";
		n++;
	    }
	    System.out.println(holder);
	    holder+="\n";
	    a=holder.getBytes();
	    headerflag=false;
	}
	else {
	    try {
		if(bif==null) System.out.println("bif is null");
		int icount = bif.read(b);
		System.out.println("icount="+icount);
		if(icount == -1) {
		    a = new byte[0];
		}
		else { 
		    if(icount == blksize) a=b;  //buffer filled
		    else {
			a = new byte[icount];
			for(int i =0; i < icount; i++) a[i]=b[i];
		    }
		}
	    }
	    catch(Exception e) {
		System.out.println("IO Exception in getBlock");
		System.out.println(e);
	    }
	    
	}
	return a;
    }

    public void closeConnection() {
	System.out.println("close connection"); 
	try {
	    if(bif != null) bif.close(); 
	    else System.out.println("bif is already closed");
	} catch (Exception e) {
	    System.out.println("cannot close input stream");
	    System.out.println(e.toString());
	}
	bif=null; 
    } 
        



}
	



